<style src="./Style.scss" lang="scss" scoped></style>
<script src="./Script.js"></script>

<template>
  <div
    data-backdrop="static"
    data-keyboard="false"
    class="modal s--modal s--modal--1100 s--modal-right animated fadeInRight"
    id="AddNewCustomerDeal"
  >
    <div class="modal-dialog">
      <div class="modal-content">
        <div class="modal-header">
          <h3 class="modal-title">
            <i
              class="icon icon-createbill-01"
              style="font-size: 24px;margin-top: -1px;display: block;margin-right: 10px;float: left;"
            ></i>
            Thêm giao dịch
          </h3>
          <button
            type="button"
            class="close"
            data-dismiss="modal"
            aria-label="Close"
            @click.prevent="reset()"
          >
            <span aria-hidden="true">
              <i class="la la-times"></i>
            </span>
          </button>
        </div>
        <div class="modal-body">
          <div
            class="s--alert m-alert m-alert--outline alert alert-success text-center"
            v-if="isCreateSuccess"
          >
            <div class="s--alert-icon">
              <i class="la la-check"></i>
            </div>
            <div class="s--alert-message">
              <h5 class="s--alert-heading">Bạn đã lưu thành công giao dịch.</h5>
              <router-link
                class="m-link m-link--primary nt-link"
                target="_blank"
                :to="{name : 'dealDetail', params : {team_id : currentTeam.team_id, deal_id : dealIdCreated} }"
              >
                Xem chi tiết giao dịch
                <i class="icon icon-external-link-01"></i>
              </router-link>
            </div>
          </div>
          <h3>Thông tin giao dịch</h3>
          <div class="m-form m-form--state m--padding-5">
            <attribute-with-data-type
              :attributes="listAttributesDefault"
              :server_errors="server_errors"
              :scope="'addNewDeal'"
              :deal="deal"
            ></attribute-with-data-type>
          </div>
          <hr style="margin-top: 1.5rem; margin-bottom: 1.5rem;" />
          <h3 style="margin-bottom: 20px;">Thông tin sản phẩm</h3>
          <div class="table-container">
            <table
              class="table table-bordered table-hover s--table s--table-customer-list nt-table-list nt-table-list-all"
            >
              <thead style="background:#F4F5F9">
                <tr>
                  <th style="width:10%;">Mã sản phẩm</th>
                  <th style="width:30%;">Tên sản phẩm</th>
                  <th class="text-right" style="width:10%;">Số lượng</th>
                  <th class="text-right" style="width:12%;">Đơn giá niêm yết</th>
                  <th class="text-center" style="width:10%;">
                    <select class="m--select-discount" @change="selectTypeDiscount($event)">
                      <option
                        :selected="deal.product_discount_type == 'percent' ? true : false"
                        value="percent"
                      >CK %</option>
                      <option
                        :selected="deal.product_discount_type == 'amount' ? true : false"
                        value="amount"
                      >CK Giá trị</option>
                    </select>
                  </th>
                  <th class="text-right" style="width:12%;">Đơn giá bán</th>
                  <th class="text-right" style="width:16%;">Thành tiền</th>
                  <th></th>
                </tr>
              </thead>
              <tbody>
                <tr v-for="(product, product_index) in deal.products" :key="product_index">
                  <template v-if="deal.products && deal.products.length > 0">
                    <td>
                      <template
                        v-if="product.product_code && product.product_code !== ''"
                      >{{product.product_code}}</template>
                    </td>
                    <td>
                      <router-link
                        style="color:#2577C9"
                        target="_blank"
                        :to="{name : 'productDetail', params : {team_id : currentTeam.team_id, product_id : product.id} }"
                      >
                        {{product.product_name }}
                        <i class="icon icon-external-link-01"></i>
                      </router-link>
                    </td>
                    <td class="text-right">
                      <input
                        class="form-control text-right"
                        v-model="product.quantity"
                        @blur="formatNumberBlur('quantity', product_index)"
                        @focus="clearFormatNumberFocus('quantity', product_index)"
                        @keyup="changeQuantityProduct(product, product_index)"
                        @keydown="setOnlyNumberInInput($event)"
                      />
                    </td>
                    <td class="text-right">{{ product.product_price | formatNumberPrice }}</td>
                    <td class="text-center">
                      <input
                        v-if="deal.product_discount_type == 'percent'"
                        class="form-control text-center"
                        v-model="product.discount"
                        @keyup="changeDiscount(product, 'percent', product_index)"
                        @keydown="setOnlyNumberInInput($event)"
                      />
                      <input
                        v-if="deal.product_discount_type == 'amount'"
                        class="form-control text-right"
                        v-model="product.discount"
                        @blur="formatNumberBlur('discount', product_index)"
                        @focus="clearFormatNumberFocus('discount', product_index)"
                        @keyup="changeDiscount(product, 'amount', product_index)"
                        @keydown="setOnlyNumberInInput($event)"
                      />
                    </td>
                    <td class="text-right">{{ product.sale_price | formatNumberPrice }}</td>
                    <td class="text-right">{{ product.total_price | formatNumberPrice }}</td>
                    <td>
                      <a
                        href="javascript:;"
                        @click="closeProductFromTable(product, product.sort_order)"
                        class="close-product"
                      >
                        <i class="fa fa-times"></i>
                      </a>
                    </td>
                  </template>
                </tr>
                <tr>
                  <td></td>
                  <td>
                    <v-select
                      v-if="isLoadProduct"
                      placeholder="Tìm kiếm và chọn sản phẩm"
                      class="add-deal-product"
                      label="product_name"
                      :options="listProducts"
                      index="id"
                      :on-change="selectProductInDeal"
                      v-model="productSelected"
                    >
                      <!-- <template slot="option" slot-scope="option"></template> -->
                      <template slot="option"></template>
                      <span slot="no-options">Không tìm thấy sản phẩm</span>
                    </v-select>
                  </td>
                  <td></td>
                  <td></td>
                  <td></td>
                  <td></td>
                  <td></td>
                  <td></td>
                </tr>
              </tbody>
            </table>
          </div>
          <div class="m-form m-form--state m--padding-5">
            <div class="row">
              <div class="col-md-6 form-group m-form__group m--padding-5">
                <div class="row">
                  <div class="col-md-8">
                    <label for="order_note" class="form-control-label s--label">Ghi chú</label>
                    <textarea
                      id="order_note"
                      v-model="noteDeal"
                      placeholder="Điền ghi chú cho đơn hàng"
                      style="max-height:123px; min-height:60px; resize:vertical;"
                      class="form-control"
                    ></textarea>
                  </div>
                </div>
              </div>
              <div class="col-md-6 form-group m-form__group m--padding-5">
                <div class="row">
                  <div class="col-md-4"></div>
                  <div class="col-md-8">
                    <div class="total-amount">
                      <label class="form-control-label s--label">Tổng thành tiền:</label>
                      <label class="pull-right form-control-label s--label">
                        {{deal.total |
                        formatNumberPrice}}
                      </label>
                    </div>
                    <div class="additional_discount">
                      <label class="form-control-label s--label">Chiết khấu thêm:</label>
                      <div style="display:inline-block; width:100%;">
                        <select
                          class="form-control pull-left col-md-3"
                          @change="selectTypeAdditionalDiscount($event)"
                        >
                          <option
                            :selected="deal.discount.type == 'percent' ? true : false"
                            value="percent"
                          >%</option>
                          <option
                            :selected="deal.discount.type == 'amount' ? true : false"
                            value="amount"
                          >Giá trị</option>
                        </select>
                        <input
                          style="margin-left:8px"
                          v-if="deal.discount.type == 'percent'"
                          class="form-control text-center pull-left col-md-4"
                          v-model="deal.discount.value"
                          @keyup="changeAdditionalDiscount('percent')"
                          @keydown="setOnlyNumberInInput($event)"
                        />
                        <input
                          style="margin-left:8px"
                          v-if="deal.discount.type == 'amount'"
                          class="form-control pull-left col-md-4 text-right"
                          @blur="formatNumberBlur('addDiscount')"
                          @focus="clearFormatNumberFocus('addDiscount')"
                          v-model="deal.discount.value"
                          @keyup="changeAdditionalDiscount('amount')"
                          @keydown="setOnlyNumberInInput($event)"
                        />
                        <label
                          class="pull-right form-control-label s--label"
                          style="display: flex;
                                                       align-items: center;
                                                       justify-content: flex-end;
                                                       width: calc(41% - 14px);
                                                       height: 40px;
                                                       margin-left : 8px;
                                                       margin-bottom :0px;"
                        >
                          <template v-if="deal.discount.total_discount > 0">-</template>
                          {{deal.discount.total_discount | formatNumberPrice}}
                        </label>
                      </div>
                    </div>
                    <hr />
                    <div class="total_transaction_amount">
                      <label class="form-control-label s--label">Tổng thanh toán:</label>
                      <label class="pull-right form-control-label s--label">
                        {{deal.total_after_discount
                        | formatNumberPrice}}
                      </label>
                    </div>
                  </div>
                </div>
              </div>
            </div>
          </div>
          <hr style="margin-top: 1.5rem; margin-bottom: 1.5rem;" />
          <h3 style="margin-bottom: 20px;">Thông tin mở rộng</h3>
          <div class="m-form m-form--state m--padding-5">
            <attribute-with-data-type
              :attributes="listAttributesExtend"
              :server_errors="server_errors"
              :scope="'addNewDeal'"
              :extend="true"
              :deal="deal"
            ></attribute-with-data-type>
          </div>
        </div>
        <div class="modal-footer">
          <button
            type="button"
            @click="reset()"
            class="btn btn-link mr-2 m-btn--custom-close"
            data-dismiss="modal"
          >Hủy bỏ</button>
          <button
            type="submit"
            :disabled="isLoader == true || errors.any()"
            @click="createDeal()"
            class="btn btn-primary m-btn m-btn--custom-submit"
          >Lưu lại</button>
        </div>
      </div>
    </div>
    <div
      class="m--loading-addnew"
      v-if="isLoader"
      style="position: absolute;height: 100%;width: 1100px;top: 0px;right: 0px;background: #ffffff94;"
    >
      <div
        class="m-loader m-loader--brand m-loader--lg"
        style="width: 30px; height: 30px; display: inline-block; position: absolute;top: 50%;left: 50%;transform: translate(-50%, -50%);"
      ></div>
    </div>
  </div>
</template>
